.IP \(bu
When NICs use VLAN stripping on receive they must pass a pointer to a
\fBvlan_group\fR when reporting the stripped tag to the networking
core.  If no \fBvlan_group\fR is in use then some drivers just drop
the extracted tag.  Drivers are supposed to only enable stripping if a
\fBvlan_group\fR is registered but not all of them do that.
.
.IP \(bu
On receive, some drivers handle priority tagged packets specially and
don't pass the tag onto the network stack at all, so Open vSwitch
never has a chance to see it.
.
.IP \(bu
Some drivers size their receive buffers based on whether a
\fBvlan_group\fR is enabled, meaning that a maximum size packet with a
VLAN tag will not fit if no \fBvlan_group\fR is configured.
.
.IP \(bu
On transmit, some drivers expect that VLAN acceleration will be used
if it is available, which can only be done if a \fBvlan_group\fR is
configured.  In these cases, the driver may fail to parse the packet
and correctly setup checksum offloading or TSO.
